/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGBATTLE_ATBARENA
#define SIGBATTLE_ATBARENA

// Sigbattle includes
#include "ActionQueue.h"
#include "Arena.h"

// Forward declaraions
class QTimer;

namespace Sigbattle
{
class ATBTimer;

class SIGBATTLE_EXPORT ATBArena : public Arena
{
    Q_OBJECT
    
    public:
        ATBArena(Sigscript::SigmodWrapper* sigmod, QList<Player*> players, const bool isWild, QObject* parent);
        
        void handleAction(TeamMember* teamMember, TeamMember::Action action);
    signals:
    public slots:
    protected slots:
        void processActions();
        void cleanUp();
    protected:
        void setupBattle();
    private:
        ActionQueue m_decisions;
        ATBTimer* m_atbTimer;
        QTimer* m_processTicker;
};
}

#endif
