/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGBATTLE_ATBTIMER
#define SIGBATTLE_ATBTIMER

// Sigbattle includes
#include "Global.h"

// Qt includes
#include <QtCore/QThread>

// Forward declarations
class QTimer;

namespace Sigbattle
{
class ActionQueue;
class ATBArena;
class Player;
class TeamMember;

class SIGBATTLE_EXPORT ATBTimer : public QThread
{
    Q_OBJECT
    
    public:
        ATBTimer(ATBArena* arena, ActionQueue& actions);
    protected slots:
        void update();
    protected:
        void run();
    private:
        void increaseMeter(TeamMember* teamMember);
        bool isOverflowed(const TeamMember* teamMember) const;
        
        ATBArena* m_arena;
        ActionQueue& m_actions;
        double m_threshold;
        QTimer* m_timer;
};

bool compareTimers(TeamMember* const & member1, TeamMember* const & member2);

}

#endif
