/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGBATTLE_CONTAINMENT
#define SIGBATTLE_CONTAINMENT

// Sigbattle includes
#include "Global.h"

// Qt includes
#include <QtCore/QMetaType>
#include <QtCore/QObject>
#include <QtCore/QUuid>

// Forward declarations
namespace Sigscript
{
class SigmodWrapper;
}

namespace Sigbattle
{
class TeamMember;

class SIGBATTLE_EXPORT Containment : public QObject
{
    Q_OBJECT
    
    public:
        Containment(Sigscript::SigmodWrapper* sigmod, QObject* parent);
        
        QList<TeamMember*> members() const;
        bool addMember(TeamMember* member);
        
        virtual bool isMutable() const = 0;
        
        TeamMember* findMember(const QUuid& id) const;
        
        Sigscript::SigmodWrapper* sigmod() const;
    signals:
    public slots:
    protected slots:
    protected:
        Sigscript::SigmodWrapper* m_sigmod;
        QList<TeamMember*> m_members;
};
}
Q_DECLARE_METATYPE(Sigbattle::Containment*)

#endif
