/*
 * Copyright 2007-2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMOD_AUTHOR
#define SIGMOD_AUTHOR

// Sigmod includes
#include "Object.h"

namespace Sigmod
{
// Forward declarations
class Sigmod;

class SIGMOD_EXPORT Author : public Object
{
    Q_OBJECT
    
    public:
        Author(const Author& author);
        Author(const Sigmod* parent, const int id);
        Author(const Author& author, const Sigmod* parent, const int id);
        Author(const QDomElement& xml, const Sigmod* parent, const int id = -1);
        
        void validate();
        
        void load(const QDomElement& xml);
        QDomElement save() const;
        
        void setName(const QString& name);
        void setEmail(const QString& email);
        void setRole(const QString& role);
        
        QString name() const;
        QString email() const;
        QString role() const;
        
        Author& operator=(const Author& rhs);
    private:
        QString m_name;
        QString m_email;
        QString m_role;
};
}

#endif
