/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMOD_GLOBAL
#define SIGMOD_GLOBAL

// Qt includes
#include <QtCore/QMetaType>
#include <QtCore/QStringList>

// KDE includes
#include <kdemacros.h>

#ifndef SIGMOD_EXPORT
# ifdef MAKE_SIGMOD_LIB
   /* We are building this library */
#  define SIGMOD_EXPORT KDE_EXPORT
# else
   /* We are using this library */
#  define SIGMOD_EXPORT KDE_IMPORT
# endif
#endif

# ifndef SIGMOD_EXPORT_DEPRECATED
#  define SIGMOD_EXPORT_DEPRECATED KDE_DEPRECATED SIGMOD_EXPORT
# endif

namespace Sigmod
{
enum Stat
{
    ST_HP = 0,
    ST_No_HP_Start = 1,
    ST_Attack = 1,
    ST_Defense = 2,
    ST_Speed = 3,
    ST_Special = 4,
    ST_End_RBY = 5,
    ST_SpecialAttack = 4,
    ST_SpecialDefense = 5,
    ST_End_GSC = 6,
    ST_Accuracy = 6,
    ST_Evasion = 7,
    ST_End_Battle = 8
};
const QStringList StatRBYStr = QStringList() << "HP" << "Attack" << "Defense" << "Speed" << "Special" << "Special" << "Accuracy" << "Evasion";
const QStringList StatGSCStr = QStringList() << "HP" << "Attack" << "Defense" << "Speed" << "Special Attack" << "Special Defense" << "Accuracy" << "Evasion";

enum Direction
{
    D_Up = 0,
    D_Down = 1,
    D_Left = 2,
    D_Right = 3,
    D_End = 4,
    D_None = 4
};
const QStringList DirectionStr = QStringList() << "Up" << "Down" << "Left" << "Right" << "None";

}
Q_DECLARE_METATYPE(Sigmod::Stat)
Q_DECLARE_METATYPE(Sigmod::Direction)

#endif
