/*
 * Copyright 2007-2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMOD_MAPWILDLISTENCOUNTER
#define SIGMOD_MAPWILDLISTENCOUNTER

// Sigmod includes
#include "Object.h"

namespace Sigmod
{
// Forward declarations
class MapWildList;

class SIGMOD_EXPORT MapWildListEncounter: public Object
{
    Q_OBJECT
    
    public:
        MapWildListEncounter(const MapWildListEncounter& encounter);
        MapWildListEncounter(const MapWildList* parent, const int id);
        MapWildListEncounter(const MapWildListEncounter& encounter, const MapWildList* parent, const int id);
        MapWildListEncounter(const QDomElement& xml, const MapWildList* parent, const int id = -1);
        
        void validate();
        
        void load(const QDomElement& xml);
        QDomElement save() const;
        
        void setSpecies(const int species);
        void setLevel(const int level);
        void setWeight(const int weight);
        
        int species() const;
        int level() const;
        int weight() const;
        
        MapWildListEncounter& operator=(const MapWildListEncounter& rhs);
    private:
        int m_species;
        int m_level;
        int m_weight;
};
}

#endif
