/*
 * Copyright 2007-2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMOD_SPECIESABILITY
#define SIGMOD_SPECIESABILITY

// Sigmod includes
#include "Object.h"

namespace Sigmod
{
// Forward declarations
class Species;

class SIGMOD_EXPORT SpeciesAbility : public Object
{
    Q_OBJECT
    
    public:
        SpeciesAbility(const SpeciesAbility& ability);
        SpeciesAbility(const Species* parent, const int id);
        SpeciesAbility(const SpeciesAbility& ability, const Species* parent, const int id);
        SpeciesAbility(const QDomElement& xml, const Species* parent, const int id = -1);
        
        void validate();
        
        void load(const QDomElement& xml);
        QDomElement save() const;
        
        void setAbility(const int ability);
        void setWeight(const int weight);
        
        int ability() const;
        int weight() const;
        
       SpeciesAbility& operator=(const SpeciesAbility& rhs);
    private:
        int m_ability;
        int m_weight;
};
}

#endif
