/*
 * Copyright 2007-2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMOD_TIME
#define SIGMOD_TIME

// Sigmod includes
#include "Object.h"

namespace Sigmod
{
// Forward declarations
class Sigmod;

class SIGMOD_EXPORT Time : public Object
{
    Q_OBJECT
    
    public:
        Time(const Time& time);
        Time(const Sigmod* parent, const int id);
        Time(const Time& time, const Sigmod* parent, const int id);
        Time(const QDomElement& xml, const Sigmod* parent, const int id = -1);
        
        void validate();
        
        void load(const QDomElement& xml);
        QDomElement save() const;
        
        void setName(const QString& name);
        void setHour(const int hour);
        void setMinute(const int minutes);
        
        QString name() const;
        int hour() const;
        int minute() const;
        
        Time& operator=(const Time& rhs);
    private:
        QString m_name;
        int m_hour;
        int m_minute;
};
}

#endif
