/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMOD_WEATHER
#define SIGMOD_WEATHER

// Sigmod includes
#include "Object.h"
#include "Script.h"

namespace Sigmod
{
// Forward declarations
class Sigmod;

class SIGMOD_EXPORT Weather : public Object
{
    Q_OBJECT
    
    public:
        Weather(const Weather& weather);
        Weather(const Sigmod* parent, const int id);
        Weather(const Weather& weather, const Sigmod* parent, const int id);
        Weather(const QDomElement& xml, const Sigmod* parent, const int id = -1);
        ~Weather();
        
        void validate();
        
        void load(const QDomElement& xml);
        QDomElement save() const;
        
        void setName(const QString& name);
        void setScript(const Script& script);
        
        QString name() const;
        Script script() const;
        
        Weather& operator=(const Weather& rhs);
    private:
        QString m_name;
        Script m_script;
};
}

#endif
