/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_COINLISTOBJECTUI
#define SIGMODR_COINLISTOBJECTUI

// Sigmodr includes
#include "ObjectUI.h"

// Form include
#include "ui_coinlistobject.h"

// Forward declarations
namespace Sigmod
{
class CoinListObject;
}

namespace Sigmodr
{
class CoinListObjectUI : public ObjectUI, private Ui::formCoinListObject
{
    Q_OBJECT
    
    public:
        CoinListObjectUI(Sigmod::CoinListObject* object, QWidget* parent);
        ~CoinListObjectUI();
    public slots:
        void apply();
        void discard();
    protected slots:
        void on_varType_activated(const int type);
        void on_varObject_activated(const int object);
        void on_varAmount_valueChanged(const int amount);
        void on_varCost_valueChanged(const int cost);
    private slots:
        void initGui();
        void setGui();
    private:
        bool m_lastType;
};
}

#endif
