/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "EggGroupUI.h"

// Sigmod includes
#include "../sigmod/EggGroup.h"

Sigmodr::EggGroupUI::EggGroupUI(Sigmod::EggGroup* eggGroup, QWidget* parent) :
        ObjectUI(parent)
{
    setupUi(this);
    setObjects(eggGroup, new Sigmod::EggGroup(*eggGroup));
}

Sigmodr::EggGroupUI::~EggGroupUI()
{
}

void Sigmodr::EggGroupUI::setGui()
{
    varName->setText(qobject_cast<Sigmod::EggGroup*>(modified())->name());
}

void Sigmodr::EggGroupUI::apply()
{
    *qobject_cast<Sigmod::EggGroup*>(original()) = *qobject_cast<Sigmod::EggGroup*>(modified());
    emit(changed(false));
}

void Sigmodr::EggGroupUI::discard()
{
    *qobject_cast<Sigmod::EggGroup*>(modified()) = *qobject_cast<Sigmod::EggGroup*>(original());
    setGui();
    emit(changed(false));
}

void Sigmodr::EggGroupUI::on_varName_textChanged(const QString& name)
{
    const int cursor = varName->cursorPosition();
    qobject_cast<Sigmod::EggGroup*>(modified())->setName(name);
    varName->setCursorPosition(cursor);
}
