/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "MapWildListUI.h"

// Sigmod includes
#include "../sigmod/MapWildList.h"

Sigmodr::MapWildListUI::MapWildListUI(Sigmod::MapWildList* wildList, QWidget* parent) :
        ObjectUI(parent)
{
    setupUi(this);
    setObjects(wildList, new Sigmod::MapWildList(*wildList));
}

Sigmodr::MapWildListUI::~MapWildListUI()
{
}

void Sigmodr::MapWildListUI::setGui()
{
    varName->setText(qobject_cast<Sigmod::MapWildList*>(modified())->name());
}

void Sigmodr::MapWildListUI::apply()
{
    *qobject_cast<Sigmod::MapWildList*>(original()) = *qobject_cast<Sigmod::MapWildList*>(modified());
    emit(changed(false));
}

void Sigmodr::MapWildListUI::discard()
{
    *qobject_cast<Sigmod::MapWildList*>(modified()) = *qobject_cast<Sigmod::MapWildList*>(original());
    setGui();
    emit(changed(false));
}

void Sigmodr::MapWildListUI::on_varName_textChanged(const QString& name)
{
    qobject_cast<Sigmod::MapWildList*>(modified())->setName(name);
}
