/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_RULESUI
#define SIGMODR_RULESUI

// Sigmodr includes
#include "ObjectUI.h"

// Form include
#include "ui_rules.h"

// Forward declarations
namespace Sigmod
{
class Rules;
}

namespace Sigmodr
{
class RulesUI : public ObjectUI, private Ui::formRules
{
    Q_OBJECT
    
    public:
        RulesUI(Sigmod::Rules* rules, QWidget* parent);
        ~RulesUI();
    public slots:
        void apply();
        void discard();
    protected slots:
        void on_boxGenders_toggled(const bool genders);
        void on_varBreeding_toggled(const bool breeding);
        void on_varCriticalDomains_toggled(const bool criticalDomains);
        void on_varHardCash_toggled(const bool hardCash);
        void on_varSwitchStyle_toggled(const bool switchStyle);
        void on_varUseTurns_toggled(const bool useTurns);
        void on_boxSplitSpecial_toggled(const bool specialSplit);
        void on_varSplitSpecialDV_toggled(const bool specialSplitDV);
        void on_boxEffortValues_toggled(const bool effortValues);
        void on_varMaxEV_valueChanged(const int maxEV);
        void on_varMaxEVPerStat_valueChanged(const int maxEVPerStat);
        void on_varBoxes_valueChanged(const int boxes);
        void on_varBoxSize_valueChanged(const int boxSize);
        void on_varMaxParty_valueChanged(const int maxParty);
        void on_varMaxFight_valueChanged(const int maxFight);
        void on_varMaxPlayers_valueChanged(const int maxPlayers);
        void on_varMaxMoves_valueChanged(const int maxMoves);
        void on_varMaxLevel_valueChanged(const int maxLevel);
        void on_varMaxHeldItems_valueChanged(const int maxHeldItems);
        void on_varMaxNatures_valueChanged(const int maxNatures);
        void on_varMaxAbilities_valueChanged(const int maxAbilities);
        void on_varMaxStages_valueChanged(const int maxStages);
        void on_varMaxMoney_valueChanged(const int maxMoney);
    private slots:
        void setGui();
};
}

#endif
