/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "SigmodrPreferences.h"

// KDE includes
#include <KConfigGroup>

// Qt includes
#include <QtGui/QCheckBox>

Sigmodr::SigmodrPreferences::SigmodrPreferences(QWidget* parent, KConfigGroup& config) :
        KDialog(parent),
        m_config(config)
{
    setCaption("Sigmodr Preferences");
    setButtons(KDialog::Ok | KDialog::Cancel);
    varReloadOnOpen = new QCheckBox("Reload files on open");
    varReloadOnOpen->setChecked(m_config.readEntry("reloadOnStart", false) ? Qt::Checked : Qt::Unchecked);
    setMainWidget(varReloadOnOpen);
}

void Sigmodr::SigmodrPreferences::save()
{
    m_config.writeEntry("reloadOnStart", varReloadOnOpen->isChecked());
    m_config.sync();
}
