/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_SPECIESITEMUI
#define SIGMODR_SPECIESITEMUI

// Sigmodr includes
#include "ObjectUI.h"

// Form include
#include "ui_speciesitem.h"

// Forward declarations
namespace Sigmod
{
class SpeciesItem;
}

namespace Sigmodr
{
class SpeciesItemUI : public ObjectUI, private Ui::formSpeciesItem
{
    Q_OBJECT
    
    public:
        SpeciesItemUI(Sigmod::SpeciesItem* item, QWidget* parent);
        ~SpeciesItemUI();
    public slots:
        void apply();
        void discard();
    protected slots:
        void on_varItem_activated(const int item);
        void on_varWeight_valueChanged(const int weight);
    private slots:
        void refreshGui();
        void setGui();
};
}

#endif
