/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_STATUSUI
#define SIGMODR_STATUSUI

// Sigmodr includes
#include "ObjectUI.h"

// Form include
#include "ui_status.h"

// Forward declarations
namespace Sigmod
{
class Status;
}

namespace Sigmodr
{
class StatusUI : public ObjectUI, private Ui::formStatus
{
    Q_OBJECT
    
    public:
        StatusUI(Sigmod::Status* status, QWidget* parent);
        ~StatusUI();
    public slots:
        void apply();
        void discard();
    protected slots:
        void on_varName_textChanged(const QString& name);
        void on_varBattleScript_valueChanged(const Sigmod::Script& battleScript);
        void on_varWorldScript_valueChanged(const Sigmod::Script& worldScript);
    private slots:
        void setGui();
};
}

#endif
