/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_GROUPING
#define SIGMODR_GROUPING

// Qt includes
#include <QtCore/QList>

// Forward declarations
namespace Sigmod
{
class Object;
}

namespace Sigmodr
{
class BaseModel;

class Grouping
{
    public:
        Grouping();
        virtual ~Grouping();
        
        virtual void addChild(BaseModel* model) = 0;
        
        virtual void addObject(Sigmod::Object* object = NULL) = 0;
        virtual void deleteObject(BaseModel* model) = 0;
    protected:
        int find(BaseModel* model) const;
        void clearData();
        
        QList<BaseModel*> m_objects;
};
}

#endif
