/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "RulesModel.h"

// Sigmodr includes
#include "../RulesUI.h"

// Sigmod includes
#include "../../sigmod/Rules.h"

// KDE includes
#include <KMenu>

Sigmodr::RulesModel::RulesModel(BaseModel* parent, Sigmod::Rules* rules) :
        ObjectModel(parent, rules)
{
}

Sigmodr::RulesModel::~RulesModel()
{
}

QVariant Sigmodr::RulesModel::data(int role) const
{
    if (role == Qt::DisplayRole)
        return m_object->className();
    else if (role == Sigmodr::BaseModel::XmlRole)
    {
        QDomDocument xml(m_object->className());
        xml.appendChild(m_object->save());
        return xml.toString();
    }
    else if (role == Sigmodr::BaseModel::WidgetRole)
    {
        QWidget* widget = new RulesUI(qobject_cast<Sigmod::Rules*>(m_object), NULL);
        return QVariant::fromValue(widget);
    }
    else if (role == Sigmodr::BaseModel::ContextMenuRole)
    {
        KMenu* menu = new KMenu;
        return QVariant::fromValue(menu);
    }
    return Sigmodr::ObjectModel::data(role);
}

void Sigmodr::RulesModel::deleteSelf()
{
}
