/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "AuthorWrapper.h"

// Sigscript includes
#include "SigmodWrapper.h"

Sigscript::AuthorWrapper* Sigscript::AuthorWrapper::create(const Sigmod::Author* author, SigmodWrapper* parent)
{
    if (!m_instances.contains(Signature(parent, author->id())))
        m_instances[Signature(parent, author->id())] = new AuthorWrapper(author, parent);
    return qobject_cast<AuthorWrapper*>(m_instances[Signature(parent, author->id())]);
}

Sigscript::AuthorWrapper::AuthorWrapper(const Sigmod::Author* author, SigmodWrapper* parent) :
        ObjectWrapper(author, parent),
        m_author(author)
{
}

QString Sigscript::AuthorWrapper::name() const
{
    return m_author->name();
}

QString Sigscript::AuthorWrapper::email() const
{
    return m_author->email();
}

QString Sigscript::AuthorWrapper::role() const
{
    return m_author->role();
}
