/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGSCRIPT_AUTHORWRAPPER
#define SIGSCRIPT_AUTHORWRAPPER

// Sigscript includes
#include "ObjectWrapper.h"

// Sigmod includes
#include "../sigmod/Author.h"

namespace Sigscript
{
class SIGSCRIPT_EXPORT AuthorWrapper : public ObjectWrapper
{
    Q_OBJECT
    
    public:
        static AuthorWrapper* create(const Sigmod::Author* author, SigmodWrapper* parent);
        
        Q_SCRIPTABLE QString name() const;
        Q_SCRIPTABLE QString email() const;
        Q_SCRIPTABLE QString role() const;
    private:
        AuthorWrapper(const Sigmod::Author* author, SigmodWrapper* parent);
        AuthorWrapper& operator=(const AuthorWrapper& rhs);
        
        const Sigmod::Author* m_author;
};
}
Q_DECLARE_METATYPE(Sigscript::AuthorWrapper*)

#endif
