/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGSCRIPT_COINLISTOBJECTWRAPPER
#define SIGSCRIPT_COINLISTOBJECTWRAPPER

// Sigscript includes
#include "ObjectWrapper.h"

// Sigmod includes
#include "../sigmod/CoinListObject.h"

namespace Sigscript
{
// Forward declarations
class CoinListWrapper;
class ItemWrapper;
class SpeciesWrapper;

class SIGSCRIPT_EXPORT CoinListObjectWrapper : public ObjectWrapper
{
    Q_OBJECT
    
    public:
        static CoinListObjectWrapper* create(const Sigmod::CoinListObject* object, CoinListWrapper* parent);
        
        Q_SCRIPTABLE Sigmod::CoinListObject::Type type(const QString& name) const;
        
        Q_SCRIPTABLE Sigmod::CoinListObject::Type type() const;
        Q_SCRIPTABLE ItemWrapper* itemObject();
        Q_SCRIPTABLE SpeciesWrapper* speciesObject();
        Q_SCRIPTABLE int amount() const;
        Q_SCRIPTABLE int cost() const;
    private:
        CoinListObjectWrapper(const Sigmod::CoinListObject* object, CoinListWrapper* parent);
        CoinListObjectWrapper& operator=(const CoinListObjectWrapper& rhs);
        
        const Sigmod::CoinListObject* m_object;
};
}
Q_DECLARE_METATYPE(Sigscript::CoinListObjectWrapper*)

#endif
