/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "CoinListWrapper.h"

// Sigscript includes
#include "CoinListObjectWrapper.h"
#include "SigmodWrapper.h"

Sigscript::CoinListWrapper* Sigscript::CoinListWrapper::create(const Sigmod::CoinList* coinList, SigmodWrapper* parent)
{
    if (!m_instances.contains(Signature(parent, coinList->id())))
        m_instances[Signature(parent, coinList->id())] = new CoinListWrapper(coinList, parent);
    return qobject_cast<CoinListWrapper*>(m_instances[Signature(parent, coinList->id())]);
}

Sigscript::CoinListWrapper::CoinListWrapper(const Sigmod::CoinList* coinList, SigmodWrapper* parent) :
        ObjectWrapper(coinList, parent),
        m_coinList(coinList)
{
}

QString Sigscript::CoinListWrapper::name() const
{
    return m_coinList->name();
}

Sigmod::Script Sigscript::CoinListWrapper::script() const
{
    return m_coinList->script();
}

Sigscript::CoinListObjectWrapper* Sigscript::CoinListWrapper::object(const int index)
{
    return CoinListObjectWrapper::create(m_coinList->object(index), this);
}

int Sigscript::CoinListWrapper::objectCount() const
{
    return m_coinList->objectCount();
}
