/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGSCRIPT_COINLISTWRAPPER
#define SIGSCRIPT_COINLISTWRAPPER

// Sigscript includes
#include "ObjectWrapper.h"

// Sigmod includes
#include "../sigmod/CoinList.h"

namespace Sigscript
{
// Forward declarations
class CoinListObjectWrapper;
class SigmodWrapper;

class SIGSCRIPT_EXPORT CoinListWrapper : public ObjectWrapper
{
    Q_OBJECT
    
    public:
        static CoinListWrapper* create(const Sigmod::CoinList* coinList, SigmodWrapper* parent);
        
        Q_SCRIPTABLE QString name() const;
        Q_SCRIPTABLE Sigmod::Script script() const;
        
        Q_SCRIPTABLE CoinListObjectWrapper* object(const int index);
        Q_SCRIPTABLE int objectCount() const;
    private:
        CoinListWrapper(const Sigmod::CoinList* coinList, SigmodWrapper* parent);
        CoinListWrapper& operator=(const CoinListWrapper& rhs);
        
        const Sigmod::CoinList* m_coinList;
};
}
Q_DECLARE_METATYPE(Sigscript::CoinListWrapper*)

#endif
