/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "MapWildListEncounterWrapper.h"

// Sigscript includes
#include "MapWildListWrapper.h"
#include "SigmodWrapper.h"

Sigscript::MapWildListEncounterWrapper* Sigscript::MapWildListEncounterWrapper::create(const Sigmod::MapWildListEncounter* encounter, MapWildListWrapper* parent)
{
    if (!m_instances.contains(Signature(parent, encounter->id())))
        m_instances[Signature(parent, encounter->id())] = new MapWildListEncounterWrapper(encounter, parent);
    return qobject_cast<MapWildListEncounterWrapper*>(m_instances[Signature(parent, encounter->id())]);
}

Sigscript::MapWildListEncounterWrapper::MapWildListEncounterWrapper(const Sigmod::MapWildListEncounter* encounter, MapWildListWrapper* parent) :
        ObjectWrapper(encounter, parent),
        m_encounter(encounter)
{
}

Sigscript::SpeciesWrapper* Sigscript::MapWildListEncounterWrapper::species()
{
    return sigmod()->species(m_encounter->species());
}

int Sigscript::MapWildListEncounterWrapper::level() const
{
    if (hasValueOfType<int>("level"))
        return valueOfType<int>("level");
    return m_encounter->level();
}

int Sigscript::MapWildListEncounterWrapper::weight() const
{
    if (hasValueOfType<int>("weight"))
        return valueOfType<int>("weight");
    return m_encounter->weight();
}
