/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "NatureWrapper.h"

// Sigscript includes
#include "SigmodWrapper.h"

Sigscript::NatureWrapper* Sigscript::NatureWrapper::create(const Sigmod::Nature* nature, SigmodWrapper* parent)
{
    if (!m_instances.contains(Signature(parent, nature->id())))
        m_instances[Signature(parent, nature->id())] = new NatureWrapper(nature, parent);
    return qobject_cast<NatureWrapper*>(m_instances[Signature(parent, nature->id())]);
}

Sigscript::NatureWrapper::NatureWrapper(const Sigmod::Nature* nature, SigmodWrapper* parent) :
        ObjectWrapper(nature, parent),
        m_nature(nature)
{
}

QString Sigscript::NatureWrapper::name() const
{
    return m_nature->name();
}

Sigmod::Fraction Sigscript::NatureWrapper::stat(const Sigmod::Stat stat) const
{
    return m_nature->stat(stat);
}

int Sigscript::NatureWrapper::weight() const
{
    return m_nature->weight();
}
