/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "SpeciesAbilityWrapper.h"

// Sigscript includes
#include "SigmodWrapper.h"
#include "SpeciesWrapper.h"

Sigscript::SpeciesAbilityWrapper* Sigscript::SpeciesAbilityWrapper::create(const Sigmod::SpeciesAbility* ability, SpeciesWrapper* parent)
{
    if (!m_instances.contains(Signature(parent, ability->id())))
        m_instances[Signature(parent, ability->id())] = new SpeciesAbilityWrapper(ability, parent);
    return qobject_cast<SpeciesAbilityWrapper*>(m_instances[Signature(parent, ability->id())]);
}

Sigscript::SpeciesAbilityWrapper::SpeciesAbilityWrapper(const Sigmod::SpeciesAbility* ability, SpeciesWrapper* parent) :
        ObjectWrapper(ability, parent),
        m_ability(ability)
{
}

Sigscript::AbilityWrapper* Sigscript::SpeciesAbilityWrapper::ability()
{
    return sigmod()->ability(m_ability->ability());
}

int Sigscript::SpeciesAbilityWrapper::weight() const
{
    return m_ability->weight();
}
