/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "SpeciesItemWrapper.h"

// Sigscript includes
#include "SigmodWrapper.h"
#include "SpeciesWrapper.h"

Sigscript::SpeciesItemWrapper* Sigscript::SpeciesItemWrapper::create(const Sigmod::SpeciesItem* item, SpeciesWrapper* parent)
{
    if (!m_instances.contains(Signature(parent, item->id())))
        m_instances[Signature(parent, item->id())] = new SpeciesItemWrapper(item, parent);
    return qobject_cast<SpeciesItemWrapper*>(m_instances[Signature(parent, item->id())]);
}

Sigscript::SpeciesItemWrapper::SpeciesItemWrapper(const Sigmod::SpeciesItem* item, SpeciesWrapper* parent) :
        ObjectWrapper(item, parent),
        m_item(item)
{
}

Sigscript::ItemWrapper* Sigscript::SpeciesItemWrapper::item()
{
    return sigmod()->item(m_item->item());
}

int Sigscript::SpeciesItemWrapper::weight() const
{
    if (hasValueOfType<int>("weight"))
        return valueOfType<int>("weight");
    return m_item->weight();
}
