/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "SpeciesMoveWrapper.h"

// Sigscript includes
#include "SigmodWrapper.h"
#include "SpeciesWrapper.h"

Sigscript::SpeciesMoveWrapper* Sigscript::SpeciesMoveWrapper::create(const Sigmod::SpeciesMove* move, SpeciesWrapper* parent)
{
    if (!m_instances.contains(Signature(parent, move->id())))
        m_instances[Signature(parent, move->id())] = new SpeciesMoveWrapper(move, parent);
    return qobject_cast<SpeciesMoveWrapper*>(m_instances[Signature(parent, move->id())]);
}

Sigscript::SpeciesMoveWrapper::SpeciesMoveWrapper(const Sigmod::SpeciesMove* move, SpeciesWrapper* parent) :
        ObjectWrapper(move, parent),
        m_move(move)
{
}

Sigscript::MoveWrapper* Sigscript::SpeciesMoveWrapper::move()
{
    return sigmod()->move(m_move->move());
}

int Sigscript::SpeciesMoveWrapper::level() const
{
    return m_move->level();
}

int Sigscript::SpeciesMoveWrapper::wild() const
{
    return m_move->wild();
}
