/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "TypeWrapper.h"

// Sigscript includes
#include "SigmodWrapper.h"

Sigscript::TypeWrapper* Sigscript::TypeWrapper::create(const Sigmod::Type* type, SigmodWrapper* parent)
{
    if (!m_instances.contains(Signature(parent, type->id())))
        m_instances[Signature(parent, type->id())] = new TypeWrapper(type, parent);
    return qobject_cast<TypeWrapper*>(m_instances[Signature(parent, type->id())]);
}

Sigscript::TypeWrapper::TypeWrapper(const Sigmod::Type* type, SigmodWrapper* parent) :
        ObjectWrapper(type, parent),
        m_type(type)
{
}

QString Sigscript::TypeWrapper::TypeWrapper::name() const
{
    return m_type->name();
}

Sigmod::Fraction Sigscript::TypeWrapper::TypeWrapper::stab() const
{
    return m_type->stab();
}
