/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "WeatherWrapper.h"

// Sigscript includes
#include "SigmodWrapper.h"

Sigscript::WeatherWrapper* Sigscript::WeatherWrapper::create(const Sigmod::Weather* weather, SigmodWrapper* parent)
{
    if (!m_instances.contains(Signature(parent, weather->id())))
        m_instances[Signature(parent, weather->id())] = new WeatherWrapper(weather, parent);
    return qobject_cast<WeatherWrapper*>(m_instances[Signature(parent, weather->id())]);
}

Sigscript::WeatherWrapper::WeatherWrapper(const Sigmod::Weather* weather, SigmodWrapper* parent) :
        ObjectWrapper(weather, parent),
        m_weather(weather)
{
}

QString Sigscript::WeatherWrapper::name() const
{
    return m_weather->name();
}

Sigmod::Script Sigscript::WeatherWrapper::script() const
{
    return m_weather->script();
}
